diff --git a/lib/handlebars/base.js b/lib/handlebars/base.js
index c2f14eb4d..c7dc08151 100644
--- a/lib/handlebars/base.js
+++ b/lib/handlebars/base.js
@@ -151,7 +151,7 @@ function registerDefaultHelpers(instance) {
             // We're running the iterations one step out of sync so we can detect
             // the last iteration without have to scan the object twice and create
             // an itermediate keys array.
-            if (priorKey) {
+            if (priorKey !== undefined) {
               execIteration(priorKey, i - 1);
             }
             priorKey = key;
diff --git a/spec/regressions.js b/spec/regressions.js
index 247c1c9b3..f04107046 100644
--- a/spec/regressions.js
+++ b/spec/regressions.js
@@ -172,4 +172,14 @@ describe('Regressions', function() {
     var result = template(context);
     equals(result, 'foo');
   });
+
+  it('GH-1021: Each empty string key', function() {
+    var data = {
+      '': 'foo',
+      'name': 'Chris',
+      'value': 10000
+    };
+
+    shouldCompileTo('{{#each data}}Key: {{@key}}\n{{/each}}', {data: data}, 'Key: \nKey: name\nKey: value\n');
+  });
 });
